﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;


namespace WindowsApplication1
{
    public delegate bool BeginCapture(Int32 hBoard);
    public delegate void Display(Int32 hBoard, Int32 no);
    public delegate bool EndCapture(Int32 hBoard);

   
    
    public partial class JHIImageBoardDemo : Form
    {
        okapi32 okApi;
        private Int32 IsSaveSeq;//1-beg,2-con,3-end
        private bool IsSaveImg = false;
        private bool IsConvertRect = true;
        private bool IsCapturing = false;
        public long TotalNo = 0;
        public static bool bSaveSeq = false;
        private Bitmap _bufferImage;
        public static Int32 width = 0;
        public static Int32 height = 0;
        public static Int32 Stride = 0;
        public static Int32 PixelFormat = 0;
        public static Rectangle rect = new Rectangle();
        public static PictureBox mShowBox;
        private int SC_MINIMIZE = 0xF020;//define for min windows size
        static BeginCapture BeginCap;
        static Display DispCap;
        static EndCapture EndCap;
        public delegate void SetShowBoxImg(PictureBox ShowImage, Image img);

     
        //static Image MyImage= null;
        protected override void WndProc(ref   Message m)
        {
            if (m.WParam.ToInt32() == SC_MINIMIZE)   //   minimize   message   
            {
                IsConvertRect = false;
                //m.Result = new IntPtr(0);   //   Take   care   of   message   
                //this.Hide();   //   Hide   the   form   
            }
            else //   Else...
            {
                IsConvertRect = true;
            }
            base.WndProc(ref m);//   ...let   Form   take   care   of   this   message   (normally)   
        }

        public JHIImageBoardDemo()
        {
            Control.CheckForIllegalCrossThreadCalls = false;
            TotalNo = 0;
            InitializeComponent();
            okApi = new okapi32();
            mShowBox = this.ShowBox;
        }

        unsafe private void btnBeginCapt_Click(object sender, EventArgs e)
        {
            string MsgBox;
            Int32 Ret = 0;
            string filename = "c:\\1.avi,mjpg";//要保存文件的文件名，.net 使用unicode编码
            char[] szFilenameW = filename.ToCharArray();//"unicode"
            //把unicode 转为ascii编码
            byte[] szFilename = Encoding.GetEncoding("ASCII").GetBytes(szFilenameW);

            BeginCap = new BeginCapture(JHIImageBoardDemo.BCapture);
            DispCap = new Display(JHIImageBoardDemo.DCapture);
            EndCap = new EndCapture(JHIImageBoardDemo.ECapture);

            Int32 OutputFreq = 0;

            bSaveSeq = chkSaveSeq.Checked;
            if (okApi.hBoard <= 0)
            {
                //if not exist display show msg on ShowBox
                MsgBox = "采集卡错误";
                LabelMsgBox.Text = MsgBox;
                return;
            }
            else { }//do next

            //判断是否有信号源信息
            OutputFreq = okapi32.okGetSignalParam(okApi.hBoard, okapi32.SIGNAL_VIDEOEXIST);
            if (OutputFreq > 0)
            {
                //设置采集buffer格式为rgb888
                okapi32.okSetCaptureParam(okApi.hBoard, 4, 1);//CAPTURE_BUFRGBFORMAT
                //设置回调函数，在回调函数中可以计数，显示
                okapi32.okSetSeqCallback(okApi.hBoard, BeginCap, DispCap, EndCap);
                if (bSaveSeq)
                {
                    //1，如果需要采集过程中保存文件， 可以调用这个函数。
                    //最后一个参数是采集帧数，采集开始以后， 这个参数不能修改。
                   

                    //2，这个函数保存的文件， 是没有经过用户处理的原始文件， 在回调函数中的
                    //图像处理， 不会保存。

                    //3， 目前的64位驱动，只能保存bmp的序列avi文件， 没有压缩格式
                    //如果需要保存压缩格式文件， 请尽快向提出。
                    fixed (byte* pFilename = szFilename)
                    {
                        Ret = okapi32.okCaptureByBuffer(okApi.hBoard, (Int32)pFilename, (Int32)0, (Int32)0);
             
                    }
                }
                else
                {
                    //不保存文件的话， 只需要把图像采集到BUFFER中
                    Ret = okapi32.okCaptureTo(okApi.hBoard, okapi32.BUFFER, (Int32)0, (Int32)(-1));
                }

                if (Ret > 0)
                {
                    MsgBox = "对象总帧率：" + Ret.ToString();
                    LabelMsgBox.Text = MsgBox;
                }
                else
                {
                    Ret = okapi32.okGetLastError();
                    MsgBox = "采集没有开始" + Ret.ToString();
                    LabelMsgBox.Text = MsgBox;
                }

            }
            else
            {
                //if not exist display show msg on ShowBox
                MsgBox = "没有信号源";
                LabelMsgBox.Text = MsgBox;
            }
            return;
        }

        private void btnStopCap_Click(object sender, EventArgs e)
        {
            string MsgBox = "";
            if (okApi.hBoard <= 0)
            {
                //if not exist display show msg on ShowBox
                MsgBox = "采集卡错误";
                LabelMsgBox.Text = MsgBox;
                return;
            }
            else { }//do next            
            //设置回调函数
        //    okapi32.okSetSeqCallback(okApi.hBoard, null, null, null);
            //停止采集
            okapi32.okStopCapture(okApi.hBoard);
        }

        private void btnSaveImg_Click(object sender, EventArgs e)
        {
            if (okApi.hBoard <= 0)
            {
                //if not exist display show msg on ShowBox
                return;
            }
            else { }//do next
            IsSaveImg = true;
        }

        private void btnSaveSeq_Click(object sender, EventArgs e)
        {
            string MsgBox = "";
        }

       

        private unsafe void JHIImageBoardDemo_Load(object sender, EventArgs e)
        {
            Int32 iIndex = -1; //the index of board
            string MsgBox = "";

            okApi.hBoard = (Int32)okapi32.okOpenBoard(&iIndex);
            //
            if (okApi.hBoard <= 0)
            {
                MsgBox = "采集卡错误";
                LabelMsgBox.Text = MsgBox;
            }
            else
            {
                MsgBox = "";
                LabelMsgBox.Text = MsgBox;
            }
        }

        private void btnSetBoardParam_Click(object sender, EventArgs e)
        {
            string MsgBox;
            if (okApi.hBoard <= 0)
            {
                //if not exist display show msg on ShowBox
                MsgBox = "采集卡错误";
                LabelMsgBox.Text = MsgBox;
                return;
            }
            else
            {
                MsgBox = "";
                LabelMsgBox.Text = MsgBox;
            }//do next

            okapi32.okOpenSetParamDlg(okApi.hBoard, (Int32)this.Handle);
        }
       
        unsafe static private bool BCapture(Int32 hBoard)
        {
            fixed (int* p1 = &width, p2 = &height, p3 = &Stride)
            {
                //使用fixed获得采集图像BUFFER宽，高，跨距
                okapi32.okGetTargetInfo(hBoard, 1, 0, (short*)p1, (short*)p2, (Int32*)p3);
                int a = 0;
                
            }
            return true;
        }
        unsafe private static void DCapture(Int32 hBoard, Int32 no)
        {

            long SaveRet = 0;
            Int32 ConvRet = 0;
            IntPtr addr = (IntPtr)0;
            byte* pDat;//addr
            Console.WriteLine(no);
            Int32 iW = 0;
            Int32 jH = 0;
            Int32 PointValue = 0;
            //mShowBox.Image = null;
            //得到采集到的数据
            addr = (IntPtr)okapi32.okGetBufferAddr(hBoard, no);
            /*在此添加图像处理函数*/
            //pDat = (byte *)addr;

            //二值算法
            /*for (jH = 0; jH < height; jH++){
                for (iW = 0; iW < width; iW++){
                    PointValue  = * (Int32*)(pDat + jH * Stride + iW * 4);
                    if (PointValue > 32768)
                    {
                        *(Int32*)(pDat + jH * Stride + iW * 4) = 65535;
                    }
                    else
                    {
                        *(Int32*)(pDat + jH * Stride + iW * 4) = 0;
                    }

                }
            }*/
            /*以下为显示图像用*/
            //根据采集目标的宽高，建立image对象，
            okapi32.RECT rect;
            okapi32.tpTextMode tmode;
            okapi32.LOGFONT lf;// = new okapi32.LOGFONT();
            lf.lfHeight = 20;
            string lfFaceName = "Arial           ";
            char[] szFaceNameW = lfFaceName.ToCharArray();//"unicode"
            byte[] szFaceName = Encoding.GetEncoding("GB2312").GetBytes(szFaceNameW);
            int szlen = szFaceName.Length;//注意根据FaceName的char长度， 决定使用Name1，Name2，Name3，Name4
            //或者在FaceName后面加入足够的空格占位
            lf.lfFaceName1 = System.BitConverter.ToInt32(szFaceName, 0);
            lf.lfFaceName2 = System.BitConverter.ToInt32(szFaceName, 4);
            lf.lfFaceName3 = System.BitConverter.ToInt32(szFaceName, 8);
            lf.lfFaceName4 = System.BitConverter.ToInt32(szFaceName, 0);

            tmode.dwForeColor = 0xffffff;
            tmode.dwBackColor = 0xf0;
            tmode.dwSetMode = 0;
            tmode.wFrameNo = (Int32)no;
            tmode.wReserved = 0;

            rect.Bottom = 300;
            rect.Top = 100;
            rect.Left = 100;
            rect.Right = 500;
            string t = "something here";//要保存文件的文件名，.net 使用unicode编码     
            char[] szTextW = t.ToCharArray();//"unicode"
            byte[] szText = Encoding.GetEncoding("GB2312").GetBytes(szTextW);

            fixed (byte* text = szText)
            {
                okapi32.okSetTextTo(hBoard, okapi32.BUFFER, &rect, &lf, &tmode, (Int32)text, t.Length);//在图像上叠加字符
            }
            /*以下为显示图像用*/
            //根据采集目标的宽高，建立image对象，
            //if (MyImage != null) {
            //    MyImage.Dispose();
           // }
            
            Image MyImage = new System.Drawing.Bitmap(width, height, Stride,
                                                System.Drawing.Imaging.PixelFormat.Format24bppRgb,
                                                addr);
            
            

            Graphics g = System.Drawing.Graphics.FromImage(MyImage);
            //把图像按照获得的ShowBox的rect， 画到image上，会缩放
            //把MyImage 赋值给mShowBox（也就是ShowBox的全局引用）
            //注意此出因为是static变量，不能使用ShowBox
            //mShowBox.Image = MyImage; 

            //使用委托的方式改变窗体
            if (mShowBox.InvokeRequired)
            {
                SetShowBoxImg _set = new SetShowBoxImg(delegate(PictureBox ShImg, Image mImg)
                {
                    ShImg.Image = mImg;
                });
                mShowBox.Invoke(_set, mShowBox, MyImage);
            }
            else
            {
                mShowBox.Image = MyImage;
            }  
        }
       
        private static bool ECapture(Int32 hBoard)
        {
            okapi32.okSetSeqCallback(hBoard, null, null, null);
            okapi32.okStopCapture(hBoard);
            return true;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            okapi32.okCloseBoard(okApi.hBoard);
            this.Close();
        }

        private void ShowBox_Paint(object sender, PaintEventArgs e)
        {

        }
    }
}

 

